=== debian/changelog ===
rocsparse (5.3.0+dfsg-2) unstable; urgency=medium

  * Source upload to trigger builds.
  * d/control: add myself to uploaders.

 -- Étienne Mollier <emollier@debian.org>  Tue, 24 Jan 2023 19:37:01 +0100

rocsparse (5.3.0+dfsg-1) unstable; urgency=medium

  * Initial release. (Closes: #1023078)

 -- Cordell Bloor <cgmb@slerp.xyz>  Fri, 06 Jan 2023 14:57:14 -0700
