=== debian/control ===
Source: rocsparse
Section: devel
Homepage: https://github.com/rocmsoftwareplatform/rocsparse
Priority: optional
Standards-Version: 4.6.2
Vcs-Git: https://salsa.debian.org/rocm-team/rocsparse.git
Vcs-Browser: https://salsa.debian.org/rocm-team/rocsparse
Maintainer: ROCm Team <debian-ai@lists.debian.org>
Uploaders: Maxime Chambonnet <maxzor@maxzor.eu>,
           Cordell Bloor <cgmb@slerp.xyz>,
           Étienne Mollier <emollier@debian.org>
Build-Depends: debhelper-compat (= 13),
               cmake,
               gfortran,
               hipcc,
               libamd-comgr-dev,
               libhsa-runtime-dev,
               rocminfo,
               patchelf,
               rocm-cmake (>= 5.3.0),
               librocprim-dev,
               python3 <!nocheck>,
               python3-yaml  <!nocheck>,
               libgtest-dev <!nocheck>
Rules-Requires-Root: no

Package: librocsparse0
Section: libs
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends},
Description: ROCm library for sparse linear algebra - library
 rocSPARSE is a library that implements BLAS operations for sparse data
 structures. It is built on the AMD ROCm platform and optimized for
 discrete AMD GPUs.
 .
 rocSPARSE provides a C99 API containing sparse level 1, sparse level 2 and
 sparse level 3 BLAS functions, as well as general matrix multiplication
 between dense and sparse matricies (GEMMI), sparse preconditioner functions,
 sparse matrix format conversion functions, and sparse matrix reordering
 functions.
 .
 It supports a variety of sparse matrix formats, including coordinate list
 in either array of structure form (COO) or structure of array form (COO SOA),
 compressed sparse row (CSR) or column (CSC), block compressed sparse row
 (BSR), general block compressed sparse row (GEBSR), and the ELLPACK-ITPACK
 format (ELL).
 .
 This package provides the AMD ROCm rocSPARSE library.

Package: librocsparse-dev
Section: libdevel
Architecture: any
Depends: librocsparse0 (= ${binary:Version}),${misc:Depends}, ${shlibs:Depends},
Description: ROCm library for sparse linear algebra - headers
 rocSPARSE is a library that implements BLAS operations for sparse data
 structures. It is built on the AMD ROCm platform and optimized for
 discrete AMD GPUs.
 .
 rocSPARSE provides a C99 API containing sparse level 1, sparse level 2 and
 sparse level 3 BLAS functions, as well as general matrix multiplication
 between dense and sparse matricies (GEMMI), sparse preconditioner functions,
 sparse matrix format conversion functions, and sparse matrix reordering
 functions.
 .
 It supports a variety of sparse matrix formats, including coordinate list
 in either array of structure form (COO) or structure of array form (COO SOA),
 compressed sparse row (CSR) or column (CSC), block compressed sparse row
 (BSR), general block compressed sparse row (GEBSR), and the ELLPACK-ITPACK
 format (ELL).
 .
 This package provides the AMD ROCm rocSPARSE development headers.
