=== debian/rules ===
#!/usr/bin/make -f
export CXX=hipcc
export DEB_BUILD_MAINT_OPTIONS = hardening=-all
export VERBOSE=1
#export HIP_CLANG_HCC_COMPAT_MODE=1

CMAKE_FLAGS = \
	-DCMAKE_BUILD_TYPE=Release \
	-DROCM_SYMLINK_LIBS=OFF \
	-DBUILD_FILE_REORG_BACKWARD_COMPATIBILITY=OFF

# Disable tests for now. They require matricies from the
# SuiteSparse Matrix Collection, which has not been packaged.
#ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
#CMAKE_FLAGS += -DBUILD_CLIENTS_TESTS=ON
#endif

%:
	dh $@ -Scmake

override_dh_auto_configure:
	dh_auto_configure -- $(CMAKE_FLAGS)

#override_dh_auto_test:
#ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
#	set -e \
#	; if [ -r /dev/kfd ] \
#	; then obj-$(DEB_HOST_MULTIARCH)/clients/staging/rocsparse-test \
#	; else echo "W: /dev/kfd unreadable: no available AMD GPU." \
#	;      echo "W: tests skipped." \
#	; fi
#endif

execute_before_dh_install:
	# Note the rpath field setting may cause reproducible build issues.
	# This should be removed earlier in the toolchain if possible.
	patchelf --remove-rpath ./debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/librocsparse.so.0.1

override_dh_dwz:
	@echo "W: debug symbols unavailable for the moment[1]."
	@echo "W: [1]: https://github.com/ROCm-Developer-Tools/hipamd/issues/17"
