=== debian/watch ===
version=4
opts="repacksuffix=+dfsg,dversionmangle=s/\+dfsg//,repack,filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%rocsparse-$1.tar.gz%" \
    https://github.com/rocmsoftwareplatform/rocsparse/tags \
    (?:.*?/)?rocm-v?(\d[\d.]*)\.tar\.gz debian
